'   2121  AT89C2051 (Bascom-51)
'     
'  .. (SVA) 19.11.2006 v1.6
'  3,5
'     



'$CRYSTAL = 22118400 '22.1184 MHz crystal
'$CRYSTAL = 14318180 '14.31818 MHz crystal
$CRYSTAL = 3580000 '3.58 MHz crystal

$regfile= "89c2051.dat"

Dim PauseTime As Word, PauseCycles As Byte,  OldMode As Byte
Dim PauseTimeBd As Word, PauseCyclesBd As Byte,  OldModeBd As Byte
Dim  WasherModeTime As Byte 


'   !!!!!!!!!!!!!!!!!!!!!!!
'Dim DefaultPause As Const 12  '=DefaultPause/3 12=4
Dim DefaultPause As Const 8  '=DefaultPause/2,5 9=4





'  
Dim CeasingModeOld as Bit
Dim WasherModeOld as Bit
Dim CeasingModeBackDefOld as Bit
'Dim UnceasingModeOld as Bit
'Dim UnceasingModeBackDefOld as Bit
Dim FrontDefgerMode as Byte '0- , 1- , 2- 
Dim BackDefogerMode as Byte	'0- , 1-  2- ()
Dim FrontWasherMode as Bit	'0-  1 - 



Dim Count As Byte


'   !!!!!!!!!!!!!!!!!!!!!!!
Dim defCount As Const 2 'defCount=  _ /2


Config Timer0 = Timer , Gate = Internal , Mode = 1
		'Timer0 = counter : timer0 operates as a counter
		'Gate = Internal  : no external gate control
		'. _ = $CRYSTAL/12/65536 =  4,5 
OldMode=0 '0  , 1-   , 
OldModeBD=0			'2 -  , 3 - 
PauseCycles=0
PauseCyclesBd=0
PauseTime=DefaultPause
PauseTimeBd=0

WasherModeTime=0 '    

CeasingModeOld=0
WasherModeOld=0
CeasingModeBackDefOld=0
'UnceasingModeOld=0
'UnceasingModeBackDefOld=0

FrontDefgerMode =0
BackDefogerMode =0
FrontWasherMode =0



'
CeasingMode Alias P3.4  '  -  1
WasherMode Alias P3.3  '+  -  1
CeasingModeBackDef Alias P3.5  '    -  1
'   
UnceasingMode Alias P3.2 '  0-  , 1-   ( )
'      
UnceasingModeBackDef  Alias P3.7  ',   -  1
'     10      1

' 
'    .     .
Defogger Alias P3.0 ' -  0
DefoggerBack Alias P3.1 '  -  0

' 
Set CeasingMode
set UnceasingMode
Set CeasingModeBackDef
Set WasherMode
Set UnceasingModeBackDef
Set Defogger
Set DefoggerBack





On Timer0 Timer_0_int
Enable Interrupts                       'enable the use of interrupts
Enable Timer0                           'enable the timer

Priority Set Timer0                     'highest priority
Start Timer0    




Do
	
'	Waitms 330 ' 1/3
'       Gosub DefoggerSub
'		Gosub BackDefoggerSub	
 

Loop

End

Timer_0_int:
	Inc Count
	If Count = defCount Then
		Gosub Keyscan
		Gosub DefoggerSub
		      
		Count = 0
	End If
Return
'     
Keyscan:
	If WasherModeOld=1 And WasherMode=1 Then
		FrontWasherMode =1
	ElseIf WasherModeOld=0 And WasherMode=0 Then
		FrontWasherMode =0
	End if
	
	'If UnceasingModeOld=0 And UnceasingMode=0 And CeasingModeOld=0 And CeasingMode=0 Then
	If UnceasingMode=0 And CeasingModeOld=0 And CeasingMode=0 Then
		FrontDefgerMode =0
	ElseIf CeasingModeOld=1 And CeasingMode=1 Then
		FrontDefgerMode =1
	'ElseIf UnceasingModeOld=1 And UnceasingMode=1 Then
	ElseIf UnceasingMode=1 Then
		FrontDefgerMode =2
	End if
	
'	If CeasingModeBackDefOld =0 And CeasingModeBackDef =0 And UnceasingModeBackDefOld=0 And UnCeasingModeBackDef=0 Then
	If CeasingModeBackDefOld =0 And CeasingModeBackDef =0 And UnCeasingModeBackDef=0 Then
		BackDefogerMode =0
	ElseIf CeasingModeBackDefOld =1 And CeasingModeBackDef =1 Then
		BackDefogerMode =1
'	ElseIf UnceasingModeBackDefOld=1 And UnCeasingModeBackDef=1 Then
	ElseIf  UnCeasingModeBackDef=1 Then
		BackDefogerMode =2
	End If
	CeasingModeOld=CeasingMode
	WasherModeOld=WasherMode
'	UnceasingModeOld=UnceasingMode
	CeasingModeBackDefOld = CeasingModeBackDef 
'	UnceasingModeBackDefOld=UnCeasingModeBackDef 
	

Return
'  
DefoggerSub:
'FrontDefgerMode =0
'BackDefogerMode =0
'FrontWasherMode =0


	If FrontWasherMode=1 then '
		'WasherModeTime=9
		WasherModeTime=6
		Reset Defogger ' 
		ReSet UnCeasingMode '   
		PauseCycles=4
			
	ElseIf WasherModeTime>0 Then
			Decr WasherModeTime
			Reset Defogger ' 
			If WasherModeTime=0 Then
				Set Defogger ' 
				Set UnCeasingMode '   
			End If
	ElseIf FrontDefgerMode=1 Then ' 
		If OldMode=2 Then '    
		 	PauseCycles=0
		End If
	
		If PauseCycles<2 Then
			Reset Defogger ' 
		Elseif PauseTime>40 And PauseCycles<4 Then '   20  2 
			Reset Defogger ' 
		Elseif PauseTime>80 And PauseCycles<6 Then '   40  3 
			Reset Defogger ' 	
		Else
			Set Defogger ' 
		End If
	
		Inc PauseCycles
		If PauseCycles>PauseTime Then
			PauseCycles=0
		End If
		OldMode=1
		
	ElseIf FrontDefgerMode=2  Then '  
		'Reset Defogger ' 
		Set Defogger ' 
		If OldMode=1 Then '     
			PauseTime=PauseCycles
			if PauseTime<6 Then
		 		PauseTime=6
		 	End If
		 	PauseCycles=2 '     
			OldMode=0
		End If
	
	Else ' 
		Set Defogger ' 
		If PauseCycles<>0 AND OldMode=0 Then  '     
			    OldMode=2
			    PauseCycles=1
		ElseIf OldMode=1  Then  '     
			    OldMode=2
			    PauseCycles=1
		ElseIf OldMode=2 Then
			Inc PauseCycles
			PauseTime=PauseCycles
			
			If PauseTime>140 Then '   ,   
				OldMode=0
				PauseTime=DefaultPause
				PauseCycles=0
			End If
			if PauseTime<6 Then
		 		PauseTime=6
		 	End If
		End If
		
	End If

'  
'BackDefoggerSub:

	If BackDefogerMode=1 Then ' 
		If OldModeBd=2 Then '    
		 	PauseCyclesBd=0
		End If
	
		If PauseCyclesBd<6 Then
			Reset DefoggerBack ' 
		Elseif PauseTimeBd>40 And PauseCyclesBd<8 Then '   20  2 
			Reset DefoggerBack ' 
		Elseif PauseTimeBd>80 And PauseCyclesBd<10 Then '   40  3 
			Reset DefoggerBack ' 	
		Else
			Set DefoggerBack ' 
		End If
	
		Inc PauseCyclesBd
		If PauseCyclesBd>PauseTimeBd Then
			PauseCyclesBd=0
		End If
		OldModeBd=1
		
	ElseIf BackDefogerMode=2  Then '  
		'Reset Defogger ' 
		Set DefoggerBack ' 
		If OldModeBd=1 Then '     
			PauseTimeBd=PauseCyclesBd
			if PauseTimeBd<8 Then
		 		PauseTimeBd=0
		 	End If
		 	PauseCyclesBd=2 '     
			OldModeBd=0
		End If
	
	Else ' 
		
		If PauseCyclesBd<>0 AND OldModeBd=0 Then  '     
			    OldModeBd=2
			    PauseCyclesBd=1
		ElseIf OldModeBd=1  Then  '     
			    OldModeBd=2
			    PauseCyclesBd=1
		ElseIf OldModeBd=2 Then
			Inc PauseCyclesBd
			PauseTimeBd=PauseCyclesBd
			
			If PauseTimeBd>240 Then '   ,   
				OldModeBd=0
				PauseTimeBd=0
				PauseCyclesBd=0
			End If
			if PauseTimeBd<6 Then
		 		PauseTimeBd=0
		 	End If
		End If
	
    	
    End If
		

Return


